
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "robots.h"

GtkWidget*
create_main_win (void)
{
  GtkWidget *main_win;
  GtkWidget *main_vbox;
  GtkWidget *play_table;
  GtkWidget *label_horiz[SIZE];
  GtkWidget *label_vert[SIZE];
  GtkWidget *statusbar_hbox;
  GtkWidget *progressbar_frame;
  register int i, j;
  char str[16];

  main_win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (main_win), "main_win", main_win);
  gtk_window_set_title (GTK_WINDOW (main_win), _("Pikvorky - robot test"));
  gtk_window_set_policy (GTK_WINDOW (main_win), FALSE, FALSE, TRUE);

  main_vbox = gtk_vbox_new (FALSE, 1);
  gtk_widget_ref (main_vbox);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "main_vbox", main_vbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_vbox);
  gtk_container_add (GTK_CONTAINER (main_win), main_vbox);

  play_table = gtk_table_new (16, 16, TRUE);
  gtk_widget_ref (play_table);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "play_table", play_table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (play_table);
  gtk_box_pack_start (GTK_BOX (main_vbox), play_table, FALSE, TRUE, 0);

  for (i = 0; i < SIZE; i++) {
  	sprintf(str, "%d", i);
  	label_horiz[i] = gtk_label_new (_(str));
  	gtk_widget_ref (label_horiz[i]);
  	gtk_object_set_data_full (GTK_OBJECT (main_win), "label_horiz", label_horiz[i],
                            	(GtkDestroyNotify) gtk_widget_unref);
  	gtk_widget_show (label_horiz[i]);
  	gtk_table_attach (GTK_TABLE (play_table), label_horiz[i], 1 + i, 2 + i, 0, 1,
                    	(GtkAttachOptions) (GTK_FILL),
                    	(GtkAttachOptions) (0), 0, 0);
  	gtk_widget_set_usize (label_horiz[i], 22, 22);
  }

  for (i = 0; i < SIZE; i++) {
  	sprintf(str, "%d", i);
  	label_vert[i] = gtk_label_new (_(str));
  	gtk_widget_ref (label_vert[i]);
  	gtk_object_set_data_full (GTK_OBJECT (main_win), "label2", label_vert[i],
                            	(GtkDestroyNotify) gtk_widget_unref);
  	gtk_widget_show (label_vert[i]);
  	gtk_table_attach (GTK_TABLE (play_table), label_vert[i], 0, 1, 1 + i, 2 + i,
                    	(GtkAttachOptions) (GTK_FILL),
                    	(GtkAttachOptions) (0), 0, 0);
  	gtk_widget_set_usize (label_vert[i], 22, 22);
  }

  for (i = 0; i < SIZE; i++) {
  	for(j = 0; j < SIZE; j++) {
  		play_frame[i][j] = gtk_frame_new (NULL);
  		gtk_widget_ref (play_frame[i][j]);
  		gtk_object_set_data_full (GTK_OBJECT (main_win), "play_frame", play_frame[i][j],
  				(GtkDestroyNotify) gtk_widget_unref);
  		gtk_widget_show (play_frame[i][j]);
  		gtk_table_attach (GTK_TABLE (play_table), play_frame[i][j], 1 + j, 2 + j, 1 + i, 2 + i,
                    		(GtkAttachOptions) (GTK_FILL),
                    		(GtkAttachOptions) (GTK_FILL), 0, 0);
  		gtk_widget_set_usize (play_frame[i][j], 22, 22);
  		gtk_frame_set_shadow_type (GTK_FRAME (play_frame[i][j]), GTK_SHADOW_IN);

  		play_label[i][j] = gtk_label_new (_(" "));
  		gtk_widget_ref (play_label[i][j]);
  		gtk_object_set_data_full (GTK_OBJECT (main_win), "play_label", play_label[i][j],
                            		(GtkDestroyNotify) gtk_widget_unref);
  		gtk_widget_show (play_label[i][j]);
  		gtk_container_add (GTK_CONTAINER (play_frame[i][j]), play_label[i][j]);
  	}
  }

/*  frame3 = gtk_frame_new (NULL);
  gtk_widget_ref (frame3);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "frame3", frame3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame3);
  gtk_table_attach (GTK_TABLE (play_table), frame3, 2, 3, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_set_usize (frame3, 22, 22);
  gtk_frame_set_shadow_type (GTK_FRAME (frame3), GTK_SHADOW_ETCHED_OUT);
*/
  statusbar_hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (statusbar_hbox);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "statusbar_hbox", statusbar_hbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar_hbox);
  gtk_box_pack_start (GTK_BOX (main_vbox), statusbar_hbox, FALSE, TRUE, 0);

  statusbar = gtk_label_new("Starting...");
  gtk_widget_ref (statusbar);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "statusbar", statusbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar);
  gtk_box_pack_start (GTK_BOX (statusbar_hbox), statusbar, TRUE, TRUE, 0);


  progressbar_frame = gtk_frame_new (NULL);
  gtk_widget_ref (progressbar_frame);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "progressbar_frame", progressbar_frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar_frame);
  gtk_box_pack_start (GTK_BOX (statusbar_hbox), progressbar_frame, FALSE, TRUE, 0);
  gtk_frame_set_shadow_type (GTK_FRAME (progressbar_frame), GTK_SHADOW_IN);

  progressbar = gtk_progress_bar_new ();
  gtk_widget_ref (progressbar);
  gtk_object_set_data_full (GTK_OBJECT (main_win), "progressbar", progressbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (progressbar);
  gtk_container_add (GTK_CONTAINER (progressbar_frame), progressbar);
  gtk_widget_set_usize (progressbar, 100, -2);
  gtk_progress_set_activity_mode (GTK_PROGRESS (progressbar), TRUE);

  timer = gtk_timeout_add(20, on_timeout, NULL);

  return main_win;
}
