
#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>
#include <string.h>
#include <signal.h>

#include "interface.h"
#include "support.h"
#include "robots.h"

void Clean_On_Exit(void) {
	Kill_Robots();
}

void on_pipe(int sig) {
	gtk_label_set_text(GTK_LABEL(statusbar), "Pipe broken.");
	stop = 1;
}

int
main (int argc, char *argv[])
{
 int i, j;
	GtkWidget *main_win;

	for(i = 0; i < SIZE; i++) {
		for (j = 0; j < SIZE; j++) {
			play_area[i][j] = ' ';
		}
	}

	signal(SIGPIPE, on_pipe);

	strcpy(rbt.px_cmd, "/usr/local/bin/piskv-rbt -a 1 -d -s 27 -n x -b > /tmp/piskv_x 2> ./dbg_x");
	strcpy(rbt.po_cmd, "/usr/local/bin/piskv-rbt -a 1 -d -s 27 -n o > /tmp/piskv_o 2> ./dbg_o");
	rbt.delay = 5;

	Launch_Robots();
	atexit(Clean_On_Exit);

#ifdef ENABLE_NLS
	bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain (PACKAGE);
#endif

	gnome_init ("piskv-tester", VERSION, argc, argv);

	main_win = create_main_win ();
	gtk_widget_show (main_win);
	gtk_signal_connect (GTK_OBJECT (main_win), "destroy",
			GTK_SIGNAL_FUNC (gtk_exit), NULL);
	gtk_signal_connect (GTK_OBJECT (main_win), "delete_event",
			GTK_SIGNAL_FUNC (gtk_exit), NULL);

	gtk_main ();
	return 0;
}

