/*
 * robots.c  -  Funkce na obsluhu robotu
 *
 * Josef Kufener <jkufner@seznam.cz>
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "robots.h"
#include "interface.h"

#define DEBUG_PRINT		1


char play_area[SIZE][SIZE];
/*****************************************************************************
 * Spusteni obou robotu
 */
int Launch_Robots(void) {

	mkfifo("/tmp/piskv_x", 0777);
	mkfifo("/tmp/piskv_o", 0777);

	rbt.px_fout = popen(rbt.px_cmd, "w");
	rbt.po_fout = popen(rbt.po_cmd, "w");

	rbt.px_fin = fopen("/tmp/piskv_x", "r");
	rbt.po_fin = fopen("/tmp/piskv_o", "r");

	return 0;
}

/*****************************************************************************
 * Zastaveni robotu
 */
int Kill_Robots(void) {
	kill(rbt.px_pid, SIGTERM);
	kill(rbt.po_pid, SIGTERM);
	return 0;
}

/*****************************************************************************
 * Kontrola tahu a vitezstvi
 */
void Check(char player, int row, int col, int row_inc, int col_inc) {
 int i;

	for (i = 0; i < 5; i++) {
		if (play_area[row + i * row_inc][col + i * col_inc] != player
				|| row + i * row_inc >= SIZE || col + i * col_inc >= SIZE
				|| row + i * row_inc < 0 || col + i * col_inc < 0) {
			return;
		}
	}

	for (i = 0; i < 5; i++) {
		gtk_frame_set_shadow_type (GTK_FRAME (play_frame[row + i * row_inc][col + i * col_inc]), GTK_SHADOW_ETCHED_OUT);
	}

	if (player == 'X')
		gtk_label_set_text(GTK_LABEL(statusbar), "'X' Vyhral !");
	else
		gtk_label_set_text(GTK_LABEL(statusbar), "'O' Vyhral !");

	stop = 1;
}

/*****************************************************************************
 * Tahy robotu
 */
int stop = 0;
void Robot_Turn(char player) {
 int row, col, ret;

	if (player == 'x') {
		ret = fscanf(rbt.px_fin, "> row = %d, col = %d;", &row, &col);
#if DEBUG_PRINT == 1
		printf("Piskv_Tester: X: row = %d, col = %d;\n", row, col);
		fflush(stdout);
#endif
		if (ret != 2) {
			stop = 1;
			return;
		};

		if (play_area[row][col] != ' ') {
			gtk_label_set_text(GTK_LABEL(statusbar), "X Tahl na jiz obsazene pole!");
			gtk_frame_set_shadow_type (GTK_FRAME (play_frame[row][col]), GTK_SHADOW_ETCHED_OUT);
			stop = 1;
		}

		getc(rbt.px_fin);	// Likvidace nadbytecneho enteru
		fprintf(rbt.po_fout, "> row = %d, col = %d;\n", row, col);
		fflush(rbt.po_fout);
		if (row >= 0 && row < SIZE && col >= 0 && col < SIZE) {
			gtk_label_set_text(GTK_LABEL(play_label[row][col]), "X");
			play_area[row][col] = 'X';
		} else {
			stop = 1;
		}
	} else {
		ret = fscanf(rbt.po_fin, "> row = %d, col = %d;", &row, &col);
#if DEBUG_PRINT == 1
		printf("Piskv_Tester: O: row = %d, col = %d;\n", row, col);
		fflush(stdout);
#endif
		if(ret != 2) {
			stop = 1;
			return;
		};

		if (play_area[row][col] != ' ') {
			gtk_label_set_text(GTK_LABEL(statusbar), "O Tahl na jiz obsazene pole !");
			gtk_frame_set_shadow_type (GTK_FRAME (play_frame[row][col]), GTK_SHADOW_ETCHED_OUT);
			stop = 1;
		}

		getc(rbt.po_fin);	// Likvidace nadbytecneho enteru
		fprintf(rbt.px_fout, "> row = %d, col = %d;\n", row, col);
		fflush(rbt.px_fout);
		if (row >= 0 && row < SIZE && col >= 0 && col < SIZE) {
			gtk_label_set_text(GTK_LABEL(play_label[row][col]), "O");
			play_area[row][col] = 'O';
		} else {
			stop = 1;
		}
	}

	/* Kontrola na petici */

	for(row = 0; row < SIZE; row ++) {
		for(col = 0; col < SIZE; col++) {
			Check('X', row, col, 0, 1);		// vpravo
			Check('X', row, col, 1, 1);		// vpravo dolu
			Check('X', row, col, 1, 0);		// dolu
			Check('X', row, col, 1, -1); 		// vlevo dolu

			Check('O', row, col, 0, 1);		// vpravo
			Check('O', row, col, 1, 1);		// vpravo dolu
			Check('O', row, col, 1, 0);		// dolu
			Check('O', row, col, 1, -1); 		// vlevo dolu
		}
	}
}
