/*
 * robots.h
 *
 * Josef Kufener <jkufner@seznam.cz>
 *
 */

#ifndef JK_ROBOTS_FN
#define JK_ROBOTS_FN

#include <stdio.h>
#include "interface.h"

#define P_X	'x'
#define P_O	'o'

extern char play_area[SIZE][SIZE];

struct rbt_turn {
	int sloupec, radek;
};

struct rbt_cfg {
	char px_cmd[512], po_cmd[512];
	unsigned long int px_pid, po_pid;
	FILE *px_fin, *px_fout, *po_fin, *po_fout, *po_ferr;
	unsigned long int delay;
} rbt;

extern int stop;
/*****************************************************************************
 * Spusteni obou robotu
 */
int Launch_Robots(void);

/*****************************************************************************
 * Zastaveni robotu
 */
int Kill_Robots(void);

void Robot_Turn(char player);

/*****************************************************************************
 * Kontrola tahu a vitezstvi
 */
struct rbt_turn victory_turn;
void Turn_Check(char player, int row, int col, int row_inc, int col_inc);
/*
 * Vytezna rada je urcena jejim nejvyssim bodem, ktery je nejvice v levo
 * a smerem teto rady.
 *
 * Smery:
 */
#define VICTORY_RIGHT		1
#define VICTORY_RIGHT_DOWN	2
#define VICTORY_DOWN		3
#define VICTORY_LEFT_DOWN	4

#endif
